Index: channel.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channel.c,v
retrieving revision 1.47
diff -u -r1.47 channel.c
--- channel.c	24 Sep 2003 19:43:14 -0000	1.47
+++ channel.c	1 Oct 2003 01:15:52 -0000
@@ -49,6 +49,9 @@
 static int shutting_down = 0;
 static int uniqueint = 0;
 
+/* set/unset from frame.c */
+int ast_channel_dtmfdebug = 0;
+
 /* XXX Lock appropriately in more functions XXX */
 
 struct chanlist {
@@ -938,6 +941,8 @@
 				result = -1;
 		}
 	}
+	if(result > 0 && ast_channel_dtmfdebug)
+		ast_verbose(VERBOSE_PREFIX_3 "Got DTMF digit '%c'\n", result);
 	return result;
 }
 
@@ -985,6 +990,8 @@
 				result = -1;
 		}
 	}
+	if(result > 0 && ast_channel_dtmfdebug)
+		ast_verbose(VERBOSE_PREFIX_3 "Got DTMF digit '%c'\n", result);
 	return result;
 }
 
Index: frame.c
===================================================================
RCS file: /usr/cvsroot/asterisk/frame.c,v
retrieving revision 1.7
diff -u -r1.7 frame.c
--- frame.c	26 Sep 2003 23:17:33 -0000	1.7
+++ frame.c	1 Oct 2003 01:15:53 -0000
@@ -520,6 +520,39 @@
 struct ast_cli_entry cli_show_codec_n =
 { { "show", "codec", NULL }, show_codec_n, "Shows a specific codec", frame_show_codec_n_usage };
 
+
+
+extern int ast_channel_dtmfdebug;
+
+static int do_dtmf_debug(int fd, int argc, char *argv[])
+{
+	ast_channel_dtmfdebug = 1;
+	return RESULT_SUCCESS;
+}
+
+static char dtmf_debug_usage[] = 
+"Usage: dtmf debug\n"
+"       Enable display of DTMF digits\n";
+
+struct ast_cli_entry cli_dtmf_debug =
+{ { "dtmf", "debug", NULL },do_dtmf_debug , "Enabled DTMF display", dtmf_debug_usage  };
+
+
+static int do_dtmf_no_debug(int fd, int argc, char *argv[])
+{
+	ast_channel_dtmfdebug = 0;
+	return RESULT_SUCCESS;
+}
+
+static char dtmf_no_debug_usage[] = 
+"Usage: dtmf no debug\n"
+"       Disable display of DTMF digits\n";
+
+struct ast_cli_entry cli_dtmf_no_debug =
+{ { "dtmf", "no", "debug", NULL },do_dtmf_no_debug , "Disable DTMF display", dtmf_no_debug_usage  };
+
+
+
 void ast_frame_dump(char *name, struct ast_frame *f, char *prefix)
 {
 	char *n = "unknown";
@@ -712,5 +745,8 @@
 	ast_cli_register(&cli_show_codecs_video);
 	ast_cli_register(&cli_show_codecs_image);
 	ast_cli_register(&cli_show_codec_n);
+	
+	ast_cli_register(&cli_dtmf_debug);
+	ast_cli_register(&cli_dtmf_no_debug);
 	return 0;	
 }
